from tkinter import Tk, BooleanVar, Label, Radiobutton,Button
import pickle

game_state = []
frame = 0

def get_settings():
    '''shows launcher and returns valid,difficulty,motion,start'''
    
    launcher = Tk()
    launcher.title("SPS Launcher")

    valid = BooleanVar() # if True, pausing, saving and cheats are disabled so that the leaderboard is enabled
    valid.set(True)
    difficulty = BooleanVar() # if True, the difficulty is normal so that the leaderboard is enabled
    difficulty.set(True)
    motion = BooleanVar() # if True, higher amount of screen shake
    motion.set(True)
    play = BooleanVar() # if True, the game starts when the launcher is closed.
    play.set(False)

    valid_text = Label(launcher,text='Practice Mode (Enables cheats, pausing, saving. Disables leaderboard):')
    valid_buttons = [Radiobutton(launcher,text="Off",variable=valid,value=True),Radiobutton(launcher,text="On",variable=valid,value=False)]
    valid_text.grid(row = 0, column = 0,columnspan=2,sticky='w')
    valid_buttons[0].grid(row = 1, column = 0,sticky='w')
    valid_buttons[1].grid(row = 1, column = 1,sticky='w')

    difficulty_text = Label(launcher,text='Difficulty (Reducing disables the leaderboard)')
    difficulty_buttons = [Radiobutton(launcher,text="Normal",variable=difficulty,value=True),Radiobutton(launcher,text="Reduced",variable=difficulty,value=False)]
    difficulty_text.grid(row = 2, column = 0,columnspan=2,sticky='w')
    difficulty_buttons[0].grid(row = 3, column = 0,sticky='w')
    difficulty_buttons[1].grid(row = 3, column = 1,sticky='w')

    motion_text = Label(launcher,text='Screen shake (does not affect gameplay)')
    motion_buttons = [Radiobutton(launcher,text="Normal",variable=motion,value=True),Radiobutton(launcher,text="Reduced",variable=motion,value=False)]
    motion_text.grid(row = 4, column = 0,columnspan=2,sticky='w')
    motion_buttons[0].grid(row = 5, column = 0,sticky='w')
    motion_buttons[1].grid(row = 5, column = 1,sticky='w')

    def start_game():
        play.set(True)
        launcher.destroy()

    def load_game():
        global game_state,frame
        with open('savegame','rb') as savefile:
            savegame = pickle.load(savefile)
            valid.set(savegame[0])
            difficulty.set(savegame[1])
            motion.set(savegame[2])
            play.set(savegame[3])
            game_state = savegame[4]
            frame = savegame[5]
        launcher.destroy()

    instruct_text = Label(launcher,text='Instructions are available in the README file')
    instruct_text.grid(row=6,column= 0, columnspan=2)

    play_button = Button(launcher,text='Play Game',command=start_game)
    load_button = Button(launcher,text='Load Game',command=load_game)
    play_button.grid(row=7,column=0,sticky='n')
    load_button.grid(row=7,column=1)
    launcher.mainloop()


    return [valid.get(),difficulty.get(),motion.get(),play.get(),game_state,frame]
